clear all
x=0:100;    
J=0.274;P=1;a=1/2;b=1/2; T=2; str="Gait-Cycle Duration = "+string(T)+" s"; %T=durata in (s) di un ciclo
%% A1 (Angle cheville)
A1P=readmatrix('A1P.csv')
A1D12=readmatrix('A1D12.csv')
A1M12=readmatrix('A1M12.csv')

xA1P=A1P(:,1);
yA1P=90-A1P(:,2);                   %% Cambiamento di riferimento
pA1P=polyfit(xA1P,yA1P,12);
fA1P=polyval(pA1P,x);
A1_P=[x ; fA1P]';
d1A1P=polyder(pA1P);
d2A1P=polyder(d1A1P);
fd2A1P=(pi/180)*(100/T)^2*polyval(d2A1P,x);
d2A1_P=[x ; fd2A1P]';

xA1D12=A1D12(:,1);
yA1D12=90-A1D12(:,2);               %% Cambiamento di riferimento 
pA1D12=polyfit(xA1D12,yA1D12,12);
fA1D12=polyval(pA1D12,x);
A1_D12=[x ; fA1D12]';
d1A1D12=polyder(pA1D12);
d2A1D12=polyder(d1A1D12);
fd2A1D12=(pi/180)*(100/T)^2*polyval(d2A1D12,x);
d2A1_D12=[x ; fd2A1D12]';

xA1M12=A1M12(:,1);
yA1M12=90-A1M12(:,2);               %% Cambiamento di riferimento
pA1M12=polyfit(xA1M12,yA1M12,12);
fA1M12=polyval(pA1M12,x);
A1_M12=[x ; fA1M12]';
d1A1M12=polyder(pA1M12);
d2A1M12=polyder(d1A1M12);
fd2A1M12=(pi/180)*(100/T)^2*polyval(d2A1M12,x);
d2A1_M12=[x ; fd2A1M12]';

%subplot(321)
figure(1)
plot(x,fA1P,'b',x,fA1D12,'g',x,fA1M12,'r')
legend('Level Ground','Slope -12%','Slope +12%');
% title('Evolution of knee angle during a walking cycle');
xlabel('Gait Cycle (%)');
ylabel('Ankle-Flexion Angle ()');
grid on
%title('A1');
%axis([0 100 0 90]);
%grid;

figure(8)
plot(x,fd2A1P,'b',x,fd2A1D12,'g',x,fd2A1M12,'r')
legend('Level Ground','Slope -12%','Slope +12%');
title(str);
xlabel('Gait Cycle (%)');
ylabel('Ankle-joint acceleration (rad/s^2)');
grid on

%% A2
A2P=readmatrix('A2P.csv')
A2D12=readmatrix('A2D12.csv')
A2M12=readmatrix('A2M12.csv')

xA2P=A2P(:,1);
yA2P=A2P(:,2);
pA2P=polyfit(xA2P,yA2P,12);
fA2P=polyval(pA2P,x);
A2_P=[x ; fA2P]';           % Standardizzazione con lo stesso x
d1A2P=polyder(pA2P);
d2A2P=polyder(d1A2P);
fd2A2P=(pi/180)*(100/T)^2*polyval(d2A2P,x);
d2A2_P=[x ; fd2A2P]';

xA2D1=A2D12(:,1);
yA2D12=A2D12(:,2);
pA2D12=polyfit(xA2D1,yA2D12,12);
fA2D12=polyval(pA2D12,x);
A2_D12=[x ; fA2D12]';           % Prendiamo i valori della regressione
d1A2D12=polyder(pA2D12);
d2A2D12=polyder(d1A2D12);
fd2A2D12=(pi/180)*(100/T)^2*polyval(d2A2D12,x);
d2A2_D12=[x ; fd2A2D12]';

xA2M12=A2M12(:,1);
yA2M1=A2M12(:,2);
pA2M12=polyfit(xA2M12,yA2M1,12);
fA2M12=polyval(pA2M12,x);
A2_M12=[x ; fA2M12]';          
d1A2M12=polyder(pA2M12);
d2A2M12=polyder(d1A2M12);
fd2A2M12=(pi/180)*(100/T)^2*polyval(d2A2M12,x);
d2A2_M12=[x ; fd2A2M12]';

%subplot(322)
figure(2)
plot(x,fA2P,'b',x,fA2D12,'g',x,fA2M12,'r')
legend('Level Ground','Slope -12%','Slope +12%');
% title('Evolution of knee angle during a walking cycle');
xlabel('Gait Cycle (%)');
ylabel('Knee-Flexion Angle ()');
grid on
%title('A2');
%axis([0 100 0 90]);
%grid;

figure(9)
plot(x,fd2A2P,'b',x,fd2A2D12,'g',x,fd2A2M12,'r')
legend('Level Ground','Slope -12%','Slope +12%');
title(str);
xlabel('Gait Cycle (%)');
ylabel('Knee-joint acceleration (rad/s^2)');
grid on

%% XA (Force antéropostérieure)
XAP=readmatrix('XAP.csv')
XAD12=readmatrix('XAD12.csv')
XAM12=readmatrix('XAM12.csv')

xXAP=XAP(:,1);
yXAP=XAP(:,2);
pXAP=polyfit(xXAP,yXAP,10);
fXAP= polyval(pXAP,x) .* (x<61) + (0*polyval(pXAP,x)) .* not(x<61);
XA_P=[x ; fXAP]';

x_XAD12=XAD12(:,1);
y_XAD12=XAD12(:,2);
pXAD12=polyfit(x_XAD12,y_XAD12,10);
fXAD12= polyval(pXAD12,x) .* (x<61) + (0*polyval(pXAD12,x)) .* not(x<61);
XA_D12=[x ; fXAD12]';

x_XAM12=XAM12(:,1);
y_XAM12=XAM12(:,2);
pXAM12=polyfit(x_XAM12,y_XAM12,10);
fXAM12= polyval(pXAM12,x) .* (x<61) + (0*polyval(pXAM12,x)) .* not(x<61);
XA_M12=[x ; fXAM12]';

%subplot(323)
figure(3)
plot(x,fXAP,'b',x,fXAD12,'g',x,fXAM12,'r');
legend('Level Ground','Slope -12%','Slope +12%');
xlabel('Gait Cycle (%)');
ylabel('GRF anterior-posterior component (%BW)');
grid on
%title('XA');
%grid on;


%% YA (Force verticale)
YAP=readmatrix('YAP.csv')
YAD12=readmatrix('YAD12.csv')
YAM12=readmatrix('YAM12.csv')

xYAP=YAP(:,1);
yYAP=YAP(:,2);
pYAP=polyfit(xYAP,yYAP,10);
fYAP= polyval(pYAP,x) .* (x<61) + (0*polyval(pYAP,x)) .* not(x<61);
YA_P=[x ; fYAP]';

x_YAD12=YAD12(:,1);
y_YAD12=YAD12(:,2);
pYAD12=polyfit(x_YAD12,y_YAD12,10);
fYAD12= polyval(pYAD12,x) .* (x<61) + (0*polyval(pYAD12,x)) .* not(x<61);
YA_D12=[x ; fYAD12]';

x_YAM12=YAM12(:,1);
y_YAM12=YAM12(:,2);
pYAM12=polyfit(x_YAM12,y_YAM12,10);
fYAM12= polyval(pYAM12,x) .* (x<61) + (0*polyval(pYAM12,x)) .* not(x<61);
YA_M12=[x ; fYAM12]';

%subplot(324)
figure(4)
plot(x,fYAP,'b',x,fYAD12,'g',x,fYAM12,'r');
legend('Level Ground','Slope -12%','Slope +12%');
xlabel('Gait Cycle (%)');
ylabel('GRF vertical component (%BW)');
grid on
%title('YA');
%grid;


%% NA
NAP=readmatrix('NAP.csv')
NAD12=readmatrix('NAD12.csv')
NAM12=readmatrix('NAM12.csv')

x_NAP=NAP(:,1);
y_NAP=NAP(:,2);
pNAP=polyfit(x_NAP,y_NAP,18);
fNAP= polyval(pNAP,x) .* (x<61) + (0*polyval(pNAP,x)) .* not(x<61);
NA_P=[x ; fNAP]';

x_NAD12=NAD12(:,1);
y_NAD12=NAD12(:,2);
pNAD12=polyfit(x_NAD12,y_NAD12,18);
fNAD12= polyval(pNAD12,x) .* (x<61) + (0*polyval(pNAD12,x)) .* not(x<61);
NA_D12=[x ; fNAD12]';

x_NAM12=NAM12(:,1);
y_NAM12=NAM12(:,2);
pNAM12=polyfit(x_NAM12,y_NAM12,18);
fNAM12= polyval(pNAM12,x) .* (x<61) + (0*polyval(pNAM12,x)) .* not(x<61);
NA_M12=[x ; fNAM12]';


%subplot(325)
figure(5)
plot(x,fNAP,'b',x,fNAD12,'g',x,fNAM12,'r');
legend('Level Ground','Slope -12%','Slope +12%');
xlabel('Gait Cycle (%)');
ylabel('N_A (Nm/kg)');
grid on
%title('NA');
%plot(x,fNAP,'b',x_NAP,y_NAP,'+b',x,fNAD12,'g',x_NAD12,y_NAD12,'+g',x,fNAM12,'r',x_NAM12,y_NAM12,'+r');
%grid;

% Calcolo di M_k (caso statico) ed  IM_k (caso con forze d'inerzia)
MKP=zeros(101,2);MKP(:,1)=x;
MKD12=zeros(101,2);MKD12(:,1)=x;
MKM12=zeros(101,2);MKM12(:,1)=x;
IMKP=zeros(101,2);IMKP(:,1)=x;
IMKD12=zeros(101,2);IMKD12(:,1)=x;
IMKM12=zeros(101,2);IMKM12(:,1)=x;
NHP=zeros(101,2);NHP(:,1)=x;
NHD12=zeros(101,2);NHD12(:,1)=x;
NHM12=zeros(101,2);NHM12(:,1)=x;
for i=1:101
MKP(i,2)=-fNAP(i)+a*(fYAP(i)*cos(fA1P(i))-fXAP(i)*sin(fA1P(i)))/100
MKD12(i,2)=-fNAD12(i)+a*(fYAD12(i)*cos(fA1D12(i))-fXAD12(i)*sin(fA1D12(i)))/100
MKM12(i,2)=-fNAM12(i)+a*(fYAM12(i)*cos(fA1M12(i))-fXAM12(i)*sin(fA1M12(i)))/100
IMKP(i,2)=-fNAP(i)+a*(fYAP(i)*cos(fA1P(i))-fXAP(i)*sin(fA1P(i)))/100+(J/100)*fd2A1P(i)
IMKD12(i,2)=-fNAD12(i)+a*(fYAD12(i)*cos(fA1D12(i))-fXAD12(i)*sin(fA1D12(i)))/100+(J/100)*fd2A1D12(i)
IMKM12(i,2)=-fNAM12(i)+a*(fYAM12(i)*cos(fA1M12(i))-fXAM12(i)*sin(fA1M12(i)))/100+(J/100)*fd2A1M12(i)
NHP(i,2)=-fNAP(i)+(fYAP(i)*(b*cos(fA1P(i)+fA2P(i))+a*cos(fA1P(i)))...
    -fXAP(i)*(b*sin(fA1P(i)+fA2P(i))+a*sin(fA1P(i))))/100
NHD12(i,2)=-fNAD12(i)+(fYAD12(i)*(b*cos(fA1D12(i)+fA2D12(i))+a*cos(fA1D12(i)))...
    -fXAD12(i)*(b*sin(fA1D12(i)+fA2D12(i))+a*sin(fA1D12(i))))/100
NHM12(i,2)=-fNAM12(i)+(fYAM12(i)*(b*cos(fA1M12(i)+fA2M12(i))+a*cos(fA1M12(i)))...
    -fXAM12(i)*(b*sin(fA1M12(i)+fA2M12(i))+a*sin(fA1M12(i))))/100
end
x_MKP=MKP(:,1);
y_MKP=-MKP(:,2);
pMKP=polyfit(x_MKP,y_MKP,12);
fMKP= polyval(pMKP,x) .* (x<61) + (0*polyval(pMKP,x)) .* not(x<61);
MK_P=[x ; fMKP]';
x_IMKP=IMKP(:,1);
y_IMKP=-IMKP(:,2);
pIMKP=polyfit(x_IMKP,y_IMKP,12);
fIMKP= polyval(pIMKP,x) .* (x<61) + (0*polyval(pIMKP,x)) .* not(x<61);
IMK_P=[x ; fIMKP]';

x_MKD12=MKD12(:,1);
y_MKD12=-MKD12(:,2);
pMKD12=polyfit(x_MKD12,y_MKD12,12);
fMKD12= polyval(pMKD12,x) .* (x<61) + (0*polyval(pMKD12,x)) .* not(x<61);
MK_D12=[x ; fMKD12]';
x_IMKD12=IMKD12(:,1);
y_IMKD12=-IMKD12(:,2);
pIMKD12=polyfit(x_IMKD12,y_IMKD12,12);
fIMKD12= polyval(pIMKD12,x) .* (x<61) + (0*polyval(pIMKD12,x)) .* not(x<61);
IMK_D12=[x ; fIMKD12]';

x_MKM12=MKM12(:,1);
y_MKM12=-MKM12(:,2);
pMKM12=polyfit(x_MKM12,y_MKM12,10);
fMKM12= polyval(pMKM12,x) .* (x<61) + (0*polyval(pMKM12,x)) .* not(x<61);
MK_M12=[x ; fMKM12]';
x_IMKM12=IMKM12(:,1);
y_IMKM12=-IMKM12(:,2);
pIMKM12=polyfit(x_IMKM12,y_IMKM12,10);
fIMKM12= polyval(pIMKM12,x) .* (x<61) + (0*polyval(pIMKM12,x)) .* not(x<61);
IMK_M12=[x ; fIMKM12]';

x_NHP=NHP(:,1);
y_NHP=NHP(:,2);
pNHP=polyfit(x_NHP,y_NHP,10);
fNHP= polyval(pNHP,x) .* (x<61) + (0*polyval(pNHP,x)) .* not(x<61);
NH_P=[x ; fNHP]';

x_NHD12=NHD12(:,1);
y_NHD12=NHD12(:,2);
pNHD12=polyfit(x_NHD12,y_NHD12,10);
fNHD12= polyval(pNHD12,x) .* (x<61) + (0*polyval(pNHD12,x)) .* not(x<61);
NH_D12=[x ; fNHD12]';

x_NHM12=NHM12(:,1);
y_NHM12=NHM12(:,2);
pNHM12=polyfit(x_NHM12,y_NHM12,8);
fNHM12= polyval(pNHM12,x) .* (x<61) + (0*polyval(pNHM12,x)) .* not(x<61);
NH_M12=[x ; fNHM12]';

figure(6)
plot(x,fMKP,'b',x,fMKD12,'g',x,fMKM12,'r');         %x,-MKM12(:,2),'+',
legend('Level Ground','Slope -12%','Slope +12%');
xlabel('Gait Cycle (%)');
ylabel('M_K (Nm/kg)');
grid on

figure(10)
plot(x,fIMKP,'b',x,fIMKD12,'g',x,fIMKM12,'r');         %x,-MKM12(:,2),'+',
legend('Level Ground','Slope -12%','Slope +12%');
title(str);
xlabel('Gait Cycle (%)');
ylabel('M_K (Nm/kg)');
grid on

figure(7)
plot(x,fNHP,'b',x,fNHD12,'g',x,fNHM12,'r'); xlim([0 61])           %x,NHM12(:,2),'+',x,NHM12(:,2),'+',
legend('Level Ground','Slope -12%','Slope +12%');
xlabel('Gait Cycle (%)');
ylabel('N_H (Nm/kg)');
grid on
